import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkOrder, ThinkOrderParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkOrder(params: ThinkOrderParam) {
  const res = await request.get<ApiResult<PageResult<ThinkOrder>>>(
    THINK_API_URL + '/think/think-order/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkOrder(params?: ThinkOrderParam) {
  const res = await request.get<ApiResult<ThinkOrder[]>>(
    THINK_API_URL + '/think/think-order',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkOrder(data: ThinkOrder) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkOrder(data: ThinkOrder) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkOrder(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkOrder(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkOrder(id: number) {
  const res = await request.get<ApiResult<ThinkOrder>>(
    THINK_API_URL + '/think/think-order/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
